<?php
defined('TYPO3_MODE') or die();

$ll = 'LLL:EXT:majordomo/Resources/Private/Language/locallang_db.xlf:';

return [
    'ctrl' => [
        'title'            => $ll . 'tx_majordomo_conf',
        'label'            => 'title',
        'tstamp'           => 'tstamp',
        'crdate'           => 'crdate',
        'cruser_id'        => 'cruser_id',
        'sortby'           => 'sorting',
        'typeicon_classes' => [
            'default' => 'tcarecords-txmajordomoconf-default',
        ],
    ],

    'interface' => [
        'showRecordFieldList' => 'title,form_wrap_header,form_class_buttonleft,form_class_buttonright,form_size_input,form_tabindex,confirm_wrap_header,confirm_wrap_prompt,confirm_wrap_wrongmail,mdom_list,mdom_mail,mdom_owner,mdom_default_mail,mdom_forbidden_emails,sender_from,sender_mail,sender_signature,sender_charset'
    ],
    'columns' => [
        'title' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.title',
            'config'  => [
                'type' => 'input',
                'size' => '30',
                'eval' => 'required',
            ],
        ],
        'form_wrap_header' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.form_wrap_header',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => '<h4>|</h4>',
            ],
        ],
        'form_class_buttons' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.form_class_buttons',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => 'tx-majordomo-pi1-buttons',
            ],
        ],
        'form_class_buttonleft' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.form_class_buttonleft',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => 'tx-majordomo-pi1-button_left',
            ],
        ],
        'form_class_buttonright' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.form_class_buttonright',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => 'tx-majordomo-pi1-button_right',
            ],
        ],
        'form_size_input' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.form_size_input',
            'config'  => [
                'type'     => 'input',
                'size'     => '4',
                'max'      => '4',
                'eval'     => 'int',
                'checkbox' => '0',
                'range'    => [
                    'upper' => '255',
                    'lower' => '10'
                ],
                'default'  => 24
            ],
        ],
        'form_tabindex' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.form_tabindex',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => '2|3|4',
            ],
        ],
        'confirm_wrap_header' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.confirm_wrap_header',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => '<h1>|</h1>',
            ],
        ],
        'confirm_wrap_prompt' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.confirm_wrap_prompt',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => '<p>|</p>',
            ],
        ],
        'confirm_wrap_wrongmail' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.confirm_wrap_wrongmail',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => '<span style="color:red;font-weight:bold;">|</span>',
            ],
        ],
        'mdom_list' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.mdom_list',
            'config'  => [
                'type' => 'input',
                'size' => '30',
                'eval' => 'trim, required',
            ],
        ],
        'mdom_mail' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.mdom_mail',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => 'majordomo@provider.com',
            ],
        ],
        'mdom_owner' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.mdom_owner',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => 'owner-list@my-domain.com',
            ],
        ],
        'mdom_default_mail' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.mdom_default_mail',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'default' => 'my.name@my-domain.com',
            ],
        ],
        'mdom_forbidden_emails' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.mdom_forbidden_emails',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'default' => 'newsletter@my-domain.com, owner-list@my-domain.com',
            ],
        ],
        'sender_from' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.sender_from',
            'config'  => [
                'type'    => 'input',
                'size'    => '30',
                'eval'    => 'trim',
                'default' => 'name <name@my-domain.com>',
            ],
        ],
        'sender_name' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.sender_name',
            'config'  => [
                'type' => 'input',
                'size' => '30',
                'eval' => 'trim',
            ],
        ],
        'sender_signature' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.sender_signature',
            'config'  => [
                'type'       => 'text',
                'renderType' => 't3editor',
                'format'     => 'html',
                'cols'       => '24',
                'rows'       => '10',
                'eval'       => 'trim',
            ],
        ],
        'sender_charset' => [
            'exclude' => 0,
            'label'   => $ll . 'tx_majordomo_conf.sender_charset',
            'config'  => [
                'type'    => 'radio',
                'items'   => [
                    [$ll . 'tx_majordomo_conf.sender_charset.I.0', '0'],
                    [$ll . 'tx_majordomo_conf.sender_charset.I.1', '1'],
                ],
                'default' => 0,
            ],
        ],
    ],
    'types'   => [
        '0' => [
            'showitem' => '--div--;LLL:EXT:majordomo/Resources/Private/Language/locallang_db.xlf:tx_majordomo_conf.div_data,
                                title, 
                            --div--;LLL:EXT:majordomo/Resources/Private/Language/locallang_db.xlf:tx_majordomo_conf.div_form,
                                form_wrap_header, form_class_buttons, form_class_buttonleft, form_class_buttonright, form_size_input, form_tabindex, 
                            --div--;LLL:EXT:majordomo/Resources/Private/Language/locallang_db.xlf:tx_majordomo_conf.div_confirm,confirm_wrap_header,
                                confirm_wrap_prompt, confirm_wrap_wrongmail, 
                            --div--;LLL:EXT:majordomo/Resources/Private/Language/locallang_db.xlf:tx_majordomo_conf.div_mdom,
                                mdom_list, mdom_mail, mdom_owner, mdom_default_mail, mdom_forbidden_emails, 
                            --div--;LLL:EXT:majordomo/Resources/Private/Language/locallang_db.xlf:tx_majordomo_conf.div_mail,
                                sender_from, sender_name, sender_signature, sender_charset'
        ]
    ],
];