<?php
namespace Netzmacher\Majordomo;

use TYPO3\CMS\Core\Utility\GeneralUtility;

/***************************************************************
*  Copyright notice
*
*  (c) 2007-2017 - Dirk Wildt <wildt.at.die-netzmacher.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


/**
 * The class tx_majordomo_pi1_zz bundles all methods for the content type form.
 *
 * @author    Dirk Wildt <wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage    tx_majordomo_pi1
 */
class tx_majordomo_pi1_zz
{

    /**
     * @var \Netzmacher\Majordomo\tx_majordomo_pi1
     */
    public $pObj = null;
    // Parent Object - Initiated by the constructor

    // Vars set by methods in the current class
    /**
     * @var array
     */
    public $conf = [];














  /**
 * The method verifies the email address, which should subscribed to or unsubscribed from the list.
 * It is only a syntax test.
 *
 * @return	string		If the mail address isn't correct it returns a html-error-message otherwise FALSE (an empty string)
 */
  function eval_email()
  {
    ///////////////////////////////////////////
    //
    // Majordomo Forbidden Mails

    // Downwards Compatibilty (upto 1.0)
    $str_value = FALSE;
    if (is_array($this->conf['majordomo.']['mail.']['forbidden.']))
    {
    	$arr_value = $this->conf['majordomo.']['mail.']['forbidden.'];
    	$str_value = implode(', ', $arr_value);
    }
    if ($str_value)
    {
      if ($this->pObj->b_drs_plugin || $this->pObj->b_drs_email)
      {
        GeneralUtility::devlog('[WARN/UPDATE] majordomo.mail.forbidden is set. The TypoScript property is depricated.', $this->pObj->extKey, 2);
        GeneralUtility::devlog('[HELP/UPDATE] Please remove it!', $this->pObj->extKey, 1);
      }
      $int_key        = count($this->pObj->arrPluginStatus['WARN']);
      $str_depricated = $this->pObj->pi_getLL('plugin_prompt_isDepricated', '', TRUE);
      $this->pObj->arrPluginStatus['WARN'][$int_key]['prompt'] = 'TypoScript majordomo.mail.forbidden '.$str_depricated;
      $this->pObj->arrPluginStatus['WARN'][$int_key]['todo']   = $this->pObj->pi_getLL('pluging_todo_rm', '', TRUE);
    }
    // Downwards Compatibilty (upto 1.0)

    if (!is_array($arr_value))       // <- Downwards Compatibilty (upto 1.0)
    {                      // <- Downwards Compatibilty (upto 1.0)
      $str_value = $this->pObj->row['mdom_forbidden_emails'];
    }                      // <- Downwards Compatibilty (upto 1.0)
    if ($this->pObj->b_drs_plugin || $this->pObj->b_drs_email)
    {
      if (!$str_value)
      {
        GeneralUtility::devlog('[INFO/PLUGIN] Forbidden Emails hasn\'t any value. It\'s OK.', $this->pObj->extKey, 3);
      }
      if ($str_value)
      {
        GeneralUtility::devlog('[INFO/PLUGIN] Forbidden Emails: '.htmlspecialchars($str_value), $this->pObj->extKey, 0);
      }
    }
    if ($this->pObj->row['mdom_default_mail'])
    {
      $str_value = $str_value.', '.$this->pObj->row['mdom_default_mail'];
    }
    if ($this->pObj->row['mdom_mail'])
    {
      $str_value = $str_value.', '.$this->pObj->row['mdom_mail'];
    }
    if ($this->pObj->row['mdom_owner'])
    {
      $str_value = $str_value.', '.$this->pObj->row['mdom_owner'];
    }
    $arr_value = explode(',', $str_value);
    foreach ($arr_value as $key => $value)
    {
      if(!$value)
      {
        unset($arr_value[$key]);
      }
      if($value)
      {
        $arr_value[$key] = trim($value);
      }
    }
    if(count($arr_value) < 1)
    {
      unset($arr_value);
      if ($this->pObj->b_drs_email)
      {
         GeneralUtility::devlog('[WARN/EMAIL] Security Risk: There is no forbidden Email.', $this->pObj->extKey, 2);
      }
      return FALSE;
    }
    if ($this->pObj->b_drs_email)
    {
    	$str_prompt = implode(', ', $arr_value);
      GeneralUtility::devlog('[INFO/EMAIL] All forbidden Emails:<br />'.$str_prompt, $this->pObj->extKey, 0);
    }
    // Majordomo Forbidden Mails


    $arrPost = GeneralUtility::_POST($this->pObj->prefixId);
    // Security Fix: TYPO3-announce Ticket#2010011310000016
    $str_mail = htmlentities($arrPost['eMail']);
    // Security Fix: TYPO3-announce Ticket#2010011310000016
    $content = ''.
'        <h1>
         '.$this->pObj->pi_getLL('mail_error_title', '', FALSE).'
        </h1>
        <p>
         '.$this->pObj->pi_getLL('mail_error_text', '', FALSE).'
        </p>
';
    $arr_wrongMail = explode('|', $this->pObj->arrConfig['wrap_wrongmail']);
    switch(TRUE) {
      case(in_array($str_mail, $arr_value)):
        $strWrongMail = $arr_wrongMail[0].$str_mail.$arr_wrongMail[1];
        if ($this->pObj->b_drs_email)
        {
           GeneralUtility::devlog('[INFO/EMAIL] Evaluation: \''.$str_mail.'\' is forbidden.', $this->pObj->extKey, 0);
        }
        break;
      case($str_mail == ''):
        $strWrongMail = $arr_wrongMail[0].$this->pObj->arrConfig['mdom_default_mail'].$arr_wrongMail;
        if ($this->pObj->b_drs_email)
        {
           GeneralUtility::devlog('[INFO/EMAIL] Evaluation: Email is empty.', $this->pObj->extKey, 0);
        }
        break;
      case(!GeneralUtility::validEmail($str_mail)):
        if ($this->pObj->b_drs_email)
        {
           GeneralUtility::devlog('[INFO/EMAIL] Evaluation: \''.$str_mail.'\' has a wrong syntax.', $this->pObj->extKey, 0);
        }
        break;
      default:
        if ($this->pObj->b_drs_email)
        {
           GeneralUtility::devlog('[INFO/EMAIL] Evaluation of \''.$str_mail.'\' is successfull.', $this->pObj->extKey, 0);
        }
        return FALSE;
    }
    $content = str_replace('###MAIL###', $strWrongMail, $content);
    return $content;
  }
}